if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[usp_s_purge_domain_workitems]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[usp_s_purge_domain_workitems]
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

CREATE procedure usp_s_purge_domain_workitems(
	@iv_date	datetime,
	@iv_status	int,
	@iv_domainid	varchar(100)
)
as
begin
	set nocount on
	CREATE TABLE #WORKITEM_IDS(id int)
	CREATE TABLE #PHYSICAL_PATH(Physical_Path nvarchar(200))
	CREATE TABLE #DOC_RESOURCE_ID_LIST(Doc_Resource_ID bigint)
	CREATE TABLE #ATTACHMENT_ID_LIST(ATTACHMENT_ID bigint)
--
	declare @LV_cancelled_status_id int
	SET @LV_cancelled_status_id = 12
	declare @LV_FINISHED_STATUS_ID int
	SET @LV_FINISHED_STATUS_ID = 2
--
	INSERT INTO #WORKITEM_IDS
	SELECT ID FROM OCM_Work_Queue owq
	  LEFT JOIN TDS_Requests tr ON tr.Reference = owq.ID
	 WHERE owq.status  = @iv_status
	   AND owq.Date < @iv_date
	   AND owq.Domain_Name = @iv_domainid
	   AND (
		  ((@iv_status = @LV_CANCELLED_STATUS_ID) OR (@iv_status = @LV_FINISHED_STATUS_ID)) OR
		  (tr.RequestId IN (
			SELECT r.RequestId FROM TDS_Requests r
			LEFT JOIN TDS_RequestChannels rc
				ON r.RequestId = rc.RequestId
			GROUP BY r.RequestId
			HAVING COUNT(rc.RequestId) = 0)))
--
	INSERT INTO #DOC_RESOURCE_ID_LIST
	SELECT DOC_Resource_ID FROM OCM_Work_Queue_Resource owqr
	  JOIN #WORKITEM_IDS owq ON owqr.Work_Item_ID = owq.ID
--
	INSERT INTO #ATTACHMENT_ID_LIST
	SELECT a.ID FROM ATTACHMENTS a
	  JOIN #WORKITEM_IDS owq ON a.OCM_Work_Queue_ID = owq.ID
--
	INSERT INTO #DOC_RESOURCE_ID_LIST
	SELECT a.SOURCE_DOC_RESOURCE_ID FROM ATTACHMENTS a
	  JOIN #WORKITEM_IDS owq ON a.OCM_Work_Queue_ID = owq.ID
--
	INSERT INTO #PHYSICAL_PATH
	SELECT Physical_Path
	  FROM Doc_Storage_Locations s
	  JOIN DOC_Resources r ON s.FSL_ID = r.FSL_ID
	  JOIN #DOC_RESOURCE_ID_LIST i ON r.DOC_Resource_ID = i.Doc_Resource_ID
--
	INSERT INTO #PHYSICAL_PATH
	SELECT PRECOMPOSED_ONH_FILE_PATH
	  FROM CONVERTED_ATTACHMENTS c
	  JOIN #ATTACHMENT_ID_LIST a ON c.ATTACHMENT_ID = a.ATTACHMENT_ID
	 WHERE PRECOMPOSED_ONH_FILE_PATH IS NOT NULL
--
	INSERT INTO #PHYSICAL_PATH
	SELECT PRECOMPOSED_METRICS_FILE_PATH
	  FROM CONVERTED_ATTACHMENTS c
	  JOIN #ATTACHMENT_ID_LIST a ON c.ATTACHMENT_ID = a.ATTACHMENT_ID
	 WHERE PRECOMPOSED_METRICS_FILE_PATH IS NOT NULL
--
	DELETE CONVERTED_ATTACHMENTS
	  FROM CONVERTED_ATTACHMENTS a
	 INNER JOIN #ATTACHMENT_ID_LIST i ON i.ATTACHMENT_ID = a.ATTACHMENT_ID
--
	DELETE ATTACHMENTS
	  FROM ATTACHMENTS a
	 INNER JOIN #ATTACHMENT_ID_LIST i ON i.ATTACHMENT_ID = a.ID
--
	 DELETE DOC_Versions
	  FROM DOC_Versions v
	 INNER JOIN #DOC_RESOURCE_ID_LIST i ON i.DOC_Resource_ID = v.DOC_Resource_ID
--
	DELETE DOC_Favorite
	  FROM DOC_Favorite f
	 INNER JOIN #DOC_RESOURCE_ID_LIST i ON i.DOC_Resource_ID = f.DOC_Resource_ID
--
	DELETE DOC_Monitors
	  FROM DOC_Monitors m
	 INNER JOIN #DOC_RESOURCE_ID_LIST i ON i.DOC_Resource_ID = m.DOC_Resource_ID
--
	DELETE DOC_Logical_Path
	  FROM DOC_Logical_Path p
	 INNER JOIN #DOC_RESOURCE_ID_LIST i ON i.DOC_Resource_ID = p.Res_ID
--
	DELETE Doc_Storage_Locations
	  FROM Doc_Storage_Locations s
	 INNER JOIN DOC_Resources r ON r.FSL_ID = s.FSL_ID
	 INNER JOIN #DOC_RESOURCE_ID_LIST i ON i.DOC_Resource_ID = r.DOC_Resource_ID
--
	DELETE OCM_Work_Queue_Operator
	  FROM OCM_Work_Queue_Operator o
	 INNER JOIN #WORKITEM_IDS i ON i.ID = o.OCM_WORK_QUEUE_ID
--
	DELETE OCM_Work_Queue_Resource
	  FROM OCM_Work_Queue_Resource r
	 INNER JOIN #WORKITEM_IDS i ON i.ID = r.WORK_ITEM_ID
--
	DELETE OCM_Work_Queue
	  FROM OCM_Work_Queue w
	 INNER JOIN #WORKITEM_IDS i ON i.ID = w.ID
--
	DELETE DOC_Resources
      FROM DOC_Resources r
     INNER JOIN #DOC_RESOURCE_ID_LIST i ON i.DOC_Resource_ID = r.DOC_Resource_ID
--
	DELETE FROM Doc_Audits
	 WHERE Action_Date < @iv_date
	   AND Domain_ID = @iv_domainid
--
	SELECT Physical_Path FROM #PHYSICAL_PATH
--
	set nocount off
end
go